################################################################################
# This is 'ocsagent.pm', a ncm-ocsagent's file
################################################################################
#
# VERSION:    0.0.3, 25/11/10 19:16
# AUTHOR:     Matthias Schroder <Matthias.Schroder@cern.ch>
# MAINTAINER: Matthias Schroder <Matthias.Schroder@cern.ch>
# LICENSE:    http://cern.ch/eu-datagrid/license.html
#
#  ** Generated file : do not edit **
#
################################################################################
# Coding style: emulate <TAB> characters with 4 spaces, thanks!
################################################################################

package NCM::Component::ocsagent;

#
# a few standard statements, mandatory for all components
#

use strict;
use NCM::Component;
use NCM::Check;
use vars qw(@ISA $EC);
@ISA = qw(NCM::Component);
$EC=LC::Exception::Context->new->will_store_all;

our $NoActionSupported = 1; 

my $mypath='/software/components/ocsagent';
my $cfgfile='/etc/sysconfig/ocsinventory-agent';


sub mySubst {
    my ($cfgfile,$key,$value,$nobackup)=@_;
    my $rc = 0;

    unless ($NoAction) {
# the [O] in the keys require quoting :(
	$rc = NCM::Check::lines($cfgfile,
				 linere => '#*\s*'.quotemeta($key).'\s*=.*',
				 goodre => quotemeta($key).'='.quotemeta($value),
				 good   => $key.'='.$value,
				 keep   => 'first',
				 add    => 'last',
				 backup => ($nobackup?undef:'.old'));
    }
    return $rc;
}

##########################################################################
sub Configure {
##########################################################################
    my ($self,$config)=@_;
    my $verbose ='';
    my ($elementPath, $key, $value);
    my $ret = 0;

    $elementPath = "$mypath"."/mode";
    if ($config->elementExists($elementPath)) {
	$key = 'OCSMODE[0]';
	$value = $config->getValue($elementPath);
	$ret+=mySubst($cfgfile,$key,$value,0);
    } else {
	$self->warn("No element $elementPath found");
    }

    $elementPath = "$mypath"."/pause";
    if ($config->elementExists($elementPath)) {
	$key = 'OCSPAUSE[0]';
	$value = $config->getValue($elementPath);
	$ret+=mySubst($cfgfile,$key,$value,0);
    } else {
	$self->warn("No element $elementPath found");
    }

    $elementPath = "$mypath"."/server";
    if ($config->elementExists($elementPath)) {
	$key = 'OCSSERVER[0]';
	$value = $config->getValue($elementPath);
	$ret+=mySubst($cfgfile,$key,$value,0);
    } else {
	$self->warn("No element $elementPath found");
    }

    $elementPath = "$mypath"."/tag";
    if ($config->elementExists($elementPath)) {
	$key = 'OCSTAG[0]';
	$value = $config->getValue($elementPath);
	$ret+=mySubst($cfgfile,$key,$value,0);
    } else {
	$self->warn("No element $elementPath found");
    }

    $self->OK("Configured ocsinventory-agent") if ($ret);

    return 1;
}


##########################################################################
sub Unconfigure {
##########################################################################
    unless ($NoAction) {
	my ($self,$config)=@_;
	
	$self->OK("Unconfigured ocsinventory-agent - nothing done");
    }
    return 1;
}

1; #required for Perl modules


### Local Variables: ///
### mode: perl ///
### End: ///
